//DRAGON SLAYER ANNOUNCEMENT SCRIPT
//by half and cass for the Dragon Slayer Gamemode

// !CompilePal::IncludeFile("sound/vo/vox_takingdamage.wav")
// !CompilePal::IncludeFile("sound/vo/vox_halfhealth.wav")
// !CompilePal::IncludeFile("sound/vo/vox_quarterhealth.wav")

// !CompilePal::IncludeFile("sound/vo/vox_enemy_takingdamage.wav")
// !CompilePal::IncludeFile("sound/vo/vox_enemy_halfhealth.wav")
// !CompilePal::IncludeFile("sound/vo/vox_enemy_quarterhealth.wav")

//Precache sounds
PrecacheSound("vo/vox_halfhealth.wav")
PrecacheSound("vo/vox_quarterhealth.wav")


//Get the starting HPs from the entities dragon_red_breakable and dragon_blu_breakable
::redDragonBreakable <- Entities.FindByName(null, "dragon_red_breakable")
::bluDragonBreakable <- Entities.FindByName(null, "dragon_blu_breakable")

::redDragonHealth <- NetProps.GetPropInt(redDragonBreakable, "m_iHealth")
::bluDragonHealth <- NetProps.GetPropInt(bluDragonBreakable, "m_iHealth")

::hasPlayedAudioRedHalf <- false
::hasPlayedAudioBluHalf <- false

::hasPlayedAudioRedQuarter <- false
::hasPlayedAudioBluQuarter <- false

//Calculate half and quarter health now as to not do it every tick
//(Assuming both dragons have equal health)
::halfHealth <- redDragonHealth / 2
::quarterHealth <- redDragonHealth / 4

//DEBUG: Print dragon healths to console
//printl("RED DRAGON HP IS: " + redDragonHealth)
//printl("BLU DRAGON HP IS: " + bluDragonHealth)

//This will be a Think function
function AnnounceHealth(){
    //Update HP every tick
    ::redDragonHealth <- NetProps.GetPropInt(redDragonBreakable, "m_iHealth")
    ::bluDragonHealth <- NetProps.GetPropInt(bluDragonBreakable, "m_iHealth")

    //Check for half HP
    //Red
    if(redDragonHealth <= halfHealth && !hasPlayedAudioRedHalf){
            //Play the voicelines
            EntFire("tf_gamerules","PlayVORed","vo/vox_halfhealth.wav")
            EntFire("tf_gamerules","PlayVOBlue","vo/vox_enemy_halfhealth.wav")
            EntFire("dragon_red_takedamage_timer_relay","Trigger")

            //Flag that we've played the audio once so we'll never play it again
            hasPlayedAudioRedHalf = true

            //DEBUG Print HP to console
            //printl("RED DRAGON HP IS: " + redDragonHealth + " AND WE HAVE PLAYED THE VO")
    }

    //Blu
    if(bluDragonHealth <= halfHealth && !hasPlayedAudioBluHalf){
            //Play the voicelines
            EntFire("tf_gamerules","PlayVOBlue","vo/vox_halfhealth.wav")
            EntFire("tf_gamerules","PlayVORed","vo/vox_enemy_halfhealth.wav")
            EntFire("dragon_blu_takedamage_timer_relay","Trigger")

            //Flag that we've played the audio once so we'll never play it again
            hasPlayedAudioBluHalf = true

            //DEBUG Print HP to console
            //printl("BLU DRAGON HP IS: " + bluDragonHealth + " AND WE HAVE PLAYED THE VO")
    }

    //Check for quarter HP
    //Red
    if(redDragonHealth <= quarterHealth && !hasPlayedAudioRedQuarter){
            //Play the voicelines
            EntFire("tf_gamerules","PlayVORed","vo/vox_quarterhealth.wav")
            EntFire("tf_gamerules","PlayVOBlue","vo/vox_enemy_quarterhealth.wav")
            EntFire("dragon_red_takedamage_timer_relay","Trigger")

            //Flag that we've played the audio once so we'll never play it again
            hasPlayedAudioRedQuarter = true

            //DEBUG Print HP to console
            //printl("RED DRAGON HP IS: " + redDragonHealth + " AND WE HAVE PLAYED THE VO")
    }

    //Blu
    if(bluDragonHealth <= quarterHealth && !hasPlayedAudioBluQuarter){
            //Play the voicelines
            EntFire("tf_gamerules","PlayVOBlue","vo/vox_quarterhealth.wav")
            EntFire("tf_gamerules","PlayVORed","vo/vox_enemy_quarterhealth.wav")
            EntFire("dragon_blu_takedamage_timer_relay","Trigger")

            //Flag that we've played the audio once so we'll never play it again
            hasPlayedAudioBluQuarter = true

            //DEBUG Print HP to console
            //printl("BLU DRAGON HP IS: " + bluDragonHealth + " AND WE HAVE PLAYED THE VO")
    }
}